public class Worker
{
    internal async Task<int> DoSomeWork(int limit, CancellationToken token)
    {
        Console.WriteLine($"DoSomeWork called with a limit of {limit}");
        int counter = 0;
        while (counter <= limit)
        {
            if (token.IsCancellationRequested)
            {
                
                // could do some clean up here, but I don't have any for this simple app
                token.ThrowIfCancellationRequested();
            }
            counter++;
            Console.WriteLine($"DoSomeWork. Limit {limit}, counter {counter}");
            await Task.Delay(1000);
        }

        Console.WriteLine($"DoSomeWork. Out of while loop. Limit {limit}, counter {counter}, cancellation requested {token.IsCancellationRequested}");
        return counter;
    }

    internal async Task<int> DoSomeOtherWork(int limit, CancellationToken token)
    {
        Console.WriteLine($"DoSomeOtherWork called with a limit of {limit}");
        int counter = 0;
        while (counter <= limit)
        {
            if (token.IsCancellationRequested)
            {
                // could do some clean up here, but I don't have any for this simple app
                token.ThrowIfCancellationRequested();
            }
            counter++;
            Console.WriteLine($"DoSomeOtherWork. Limit {limit}, counter {counter}");
            await Task.Delay(1000);
        }

        Console.WriteLine($"DoSomeOtherWork. Out of while loop. Limit {limit}, counter {counter}, cancellation requested {token.IsCancellationRequested}");
        return counter;
    }
}